" vim: tw=0 ts=4 sw=4
" Vim color file
"
" Creator: David Mertz <mertz@gnosis.cx>
" Credits: Based on 'golden' by Ryan Phillips <ryan@trolocsis.com>
"          http://www.trolocsis.com/vim/golden.vim
"          This color scheme originated from the idea of 
"          Jeffrey Bakker, the creator of webcpp (http://webcpp.sourceforge.net/).
"
" A color scheme meant to 'play nice' with old-school green-on-black terminals

hi clear
set background=dark
if exists("syntax_on")
  syntax reset
endif

  let g:colors_name = "greenscreen"
  hi Normal		  	ctermfg=green guifg=green guibg=black
  hi Scrollbar	  	ctermfg=Yellow 
  hi Menu			ctermfg=darkyellow 
  hi SpecialKey	  	ctermfg=yellow term=bold  cterm=bold  
  hi NonText		ctermfg=LightBlue term=bold  cterm=bold  
  hi Directory	  	ctermfg=DarkYellow term=bold  cterm=bold  
  hi ErrorMsg		term=standout  cterm=bold  ctermfg=White  ctermbg=Red  
  hi Search			term=reverse	ctermfg=white  ctermbg=red	
  hi MoreMsg		term=bold  cterm=bold  ctermfg=Yellow
  hi ModeMsg		term=bold  ctermfg=DarkYellow cterm=bold
  hi LineNr		  	term=underline ctermfg=Brown cterm=bold 
  hi Question		term=standout  cterm=bold  ctermfg=Brown
  hi StatusLine	    cterm=bold ctermfg=white ctermbg=cyan
  hi StatusLineNC   term=reverse ctermfg=white ctermbg=black 
  hi Title		  	term=bold  cterm=bold  ctermfg=brown  
  hi Visual		  	term=reverse cterm=reverse 
  hi WarningMsg	  	term=standout  cterm=bold  ctermfg=darkblue 
  hi Cursor		    ctermbg=Brown
  hi CursorLine     term=underline 
  hi Comment		term=bold  cterm=bold ctermfg=brown
  hi Constant		term=underline cterm=bold ctermfg=lightred
  hi Special		term=bold  cterm=bold ctermfg=red 
  hi Identifier	  	term=underline ctermfg=yellow 
  hi Keyword       	term=bold ctermfg=white cterm=bold
  hi Statement	  	term=bold ctermfg=white cterm=bold 
  hi PreProc		term=underline  ctermfg=brown
  hi Type			term=underline  cterm=bold ctermfg=lightgreen 
  hi Error		  	term=reverse ctermfg=white  ctermbg=black
  hi Todo			term=bold  ctermfg=lightblue ctermbg=yellow 
  hi VertSplit      ctermfg=black ctermbg=darkgrey
  hi Folded         ctermfg=yellow
  hi ColorColumn    ctermfg=white ctermbg=black
  hi Conceal        ctermfg=cyan

  hi link IncSearch		Visual
  hi link String		Constant
  hi link Character		Constant
  hi link Number		Constant
  hi link Boolean		Constant
  hi link Float			Number
  hi link Function		Identifier
  hi link Conditional	Statement
  hi link Repeat		Statement
  hi link Label			Statement
  hi link Operator		Statement
  hi link Exception		Statement
  hi link Include		PreProc
  hi link Define		PreProc
  hi link Macro			PreProc
  hi link PreCondit		PreProc
  hi link StorageClass	Type
  hi link Structure		Type
  hi link Typedef		Type
  hi link Tag			Special
  hi link SpecialChar	Special
  hi link Delimiter		Special
  hi link SpecialComment Special
  hi link Debug			Special

